Subject: Re: [PATCH v3 net-next 2/2] tc: add 'needs_l2' flag to ingress qdisc

From: Alexei Starovoitov <[email-masked]>
Date: Wed, 08 Apr 2015 20:39:59 -0700

On 4/8/15 8:14 PM, David Miller wrote:
> From: Alexei Starovoitov <[email-masked]>
> Date: Wed, 08 Apr 2015 20:05:13 -0700
>
>> I'm sure there is a way to propagate the offset into the programs.
>> It's not about efficiency of programs, but about consistency.
>> Programs should know nothing about kernel. Sending network offset
>> into them is exposing this very specific kernel behavior.
>
> It can be performed by the data access helpers the JIT'd programs
> have to invoke anyways.

hmm, not sure what you mean.
Let's take specific line from sockex1_kern.c:
int index = load_byte(skb, ETH_HLEN + offsetof(struct iphdr, protocol));
this C code is compiled into
R0 = LD_ABS_B 23
(instruction with fixed offset)
which is being interpreted as:
skb_header_pointer(skb, 23, 1, buffer);
and similar by JITs which are using doing
r0 = *(char *)(skb->data + 23)
in this case.

Are you proposing to change semantics of LD_ABS instruction to use
skb->head + skb->mac_header instead of skb->data in interpreter
and in all JITs?
Performance wise it will be ok, since JITs can cache that pointer.
But that will be huge and very risky change.
I'm not sure yet whether all programs will keep working afterwards.
Is it really worth taking so much risk vs push/pull of L2?
If you say, let's take the risk, sure, I can try hacking all the bits
and see what the cost.